<%@ Language=VBScript%>
<!--#include file="EBAXML.inc"-->
<%
	Function ProcessFlaggingColor(OutstandingBalance, InvoicePostDate)
		ResultString = "#FFFFFF"

		if OutstandingBalance > 0 then

			ResultString = "#F0F0F0"

			if DateDiff("m", InvoicePostDate, Now()) > 0 then

				ResultString = "#FFF2F2"

			end if


		end if

		ProcessFlaggingColor = ResultString

	End Function

	Function ProcessFlaggingImage(OutstandingBalance, InvoicePostDate)
		ResultString = ""

		if OutstandingBalance > 0 then

			ResultString = "images\waitsmall.gif"

			if DateDiff("m", InvoicePostDate, Now()) > 0 then

				ResultString = "images\attentionsmall.gif"

			end if


		end if

		ProcessFlaggingImage = ResultString

	End Function





	Function GetCustomerBalance(CustomerIDNum)


		MyBalance = 0

		NewQuery = "SELECT * FROM tblInvoices WHERE CustomerID = " & CustomerIDNum
		Set NewRecordSet = objConn.execute(NewQuery)

		do while not NewRecordSet.eof

			MyBalance = MyBalance + cdbl(NewRecordSet("TotalValue")) - cdbl(NewRecordSet("PaidTotal"))

			NewRecordSet.MoveNext
		loop

		GetCustomerBalance = MyBalance

	End Function







	Function GetCustomerInvoiceCount(CustomerIDNum)


		MyCount = 0

		NewQuery = "SELECT * FROM tblInvoices WHERE CustomerID = " & CustomerIDNum
		Set NewRecordSet = objConn.execute(NewQuery)

		do while not NewRecordSet.eof

			MyCount = MyCount + 1

			NewRecordSet.MoveNext
		loop

		GetCustomerInvoiceCount = MyCount

	End Function



	' *******************************************************************
	' This code block just sets up the database and tries to figure out what index number
	' our data starts at. This code has nothing to do with the grid itself so think of it as
	' business logic.
	' *******************************************************************


	dim accessdb
	dim strconn
	dim RecordSet
	dim objConn
 	accessdb=server.mappath(".") & "\data\accounts.mdb"
  	strconn="PROVIDER=Microsoft.Jet.OLEDB.4.0;DATA SOURCE=" & accessDB & ";USER ID=;PASSWORD=;"

	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.open strconn



	DIM CompanyID
	CompanyID = ""

	CompanyID = Request.Querystring("companyid")



	DIM PageSize
	PageSize = 0

	PageSize = cInt(Request.Querystring("PageSize"))

	if PageSize < 10 then
		PageSize=10
	end if


	DIM Start
	Start = 0

	Start = cInt(Request.Querystring("Start"))


	if Start < 0 then
		Start = 0
	end if





	if Request.Querystring("grid") = "InvoiceGrid" then


		NewQuery = "SELECT * FROM tblInvoices"

		if (ucase(CompanyID) = "ALL") then
			NewQuery = NewQuery & " ORDER BY InvoiceDate DESC"
		else

			if (ucase(CompanyID) = "SEARCH") then
				NewQuery = NewQuery & " WHERE InvoiceID LIKE '" & Request.QueryString("invoiceid") & "%' ORDER BY InvoiceDate DESC"
			else

				NewQuery = NewQuery & " WHERE CustomerID = " & CompanyID  & " ORDER BY InvoiceDate DESC"

			end if

		end if


		Set RecordSet = objConn.execute(NewQuery)


		' *******************************************************************
		' Lets Set up the Output
		' *******************************************************************

		EBAGetHandler_ProcessRecords   ' We set up the getHandler and define the column CustomerID as our Index

		' First we define how many columns we are sending in each record, and name each field.

		' We will do this by using the EBAGetHandler_DefineField function. We will name each
		' field of data after its column name in the database.

		EBAGetHandler_DefineField("ProductID")
		EBAGetHandler_DefineField("Note")
		EBAGetHandler_DefineField("TotalValue")
		EBAGetHandler_DefineField("PaidTotal")
		EBAGetHandler_DefineField("Balance")
		EBAGetHandler_DefineField("InvoiceDate")
		EBAGetHandler_DefineField("CustomerID")
		EBAGetHandler_DefineField("CustomerName")
		EBAGetHandler_DefineField("FlaggingColor")
		EBAGetHandler_DefineField("InvoiceID")

		' *******************************************************************
		' Lets loop through our data and send it to the grid
		' *******************************************************************


		RecordCount = -1


		do while not RecordSet.eof


			RecordCount = RecordCount + 1

			if (RecordCount > Start-1) and (RecordCount < Start+PageSize) then

				InvoiceID = RecordSet("InvoiceID")
				TotalValue = RecordSet("TotalValue")
				PaidTotal = RecordSet("PaidTotal")
				InvoiceDate = RecordSet("InvoiceDate")
				FlagColor = ""

				FlagColor = ProcessFlaggingColor(TotalValue-PaidTotal, InvoiceDate)

				NoteImage = ""

				NoteImage = ProcessFlaggingImage(TotalValue-PaidTotal, InvoiceDate)

				EBAGetHandler_CreateNewRecord(InvoiceID)
					EBAGetHandler_DefineRecordFieldValue "ProductID", RecordSet("ProductID")
					EBAGetHandler_DefineRecordFieldValue "Note", NoteImage
					EBAGetHandler_DefineRecordFieldValue "TotalValue", TotalValue
					EBAGetHandler_DefineRecordFieldValue "PaidTotal", PaidTotal
					EBAGetHandler_DefineRecordFieldValue "Balance", TotalValue-PaidTotal
					EBAGetHandler_DefineRecordFieldValue "InvoiceDate", EBAGetHandler_ConvertDate(InvoiceDate)
					EBAGetHandler_DefineRecordFieldValue "CustomerID", RecordSet("CustomerID")
					EBAGetHandler_DefineRecordFieldValue "CustomerName", RecordSet("CustomerName")
					EBAGetHandler_DefineRecordFieldValue "FlaggingColor", FlagColor
					EBAGetHandler_DefineRecordFieldValue "InvoiceID", InvoiceID
				EBAGetHandler_SaveRecord

			end if

			RecordSet.MoveNext
		loop

		EBAGetHandler_CompleteGet

	end if































	if Request.Querystring("grid") = "CustomerGrid" then


		'NewQuery = "SELECT * FROM tblCustomers ORDER BY CustomerID DESC"'


		NewQuery = "SELECT * FROM tblCustomers"

		if (len(request.querystring("CustomerName")) > 0) then
			NewQuery = NewQuery & " WHERE CustomerName LIKE '" & Request.Querystring("CustomerName") & "%' ORDER BY CustomerName DESC"
		else

			NewQuery = NewQuery & " ORDER BY CustomerID DESC"

		end if

		Set RecordSet = objConn.execute(NewQuery)

		' *******************************************************************
		' Lets Set up the Output
		' *******************************************************************

		EBAGetHandler_ProcessRecords   ' We set up the getHandler and define the column CustomerID as our Index

		' First we define how many columns we are sending in each record, and name each field.

		' We will do this by using the EBAGetHandler_DefineField function. We will name each
		' field of data after its column name in the database.

		EBAGetHandler_DefineField("CustomerID")
		EBAGetHandler_DefineField("CustomerName")
		EBAGetHandler_DefineField("CustomerBalance")
		EBAGetHandler_DefineField("CustomerAddress")
		EBAGetHandler_DefineField("CustomerPhone")
		EBAGetHandler_DefineField("ContactEmail")
		EBAGetHandler_DefineField("CustomerInvoiceCount")

		' *******************************************************************
		' Lets loop through our data and send it to the grid
		' *******************************************************************

		RecordCount = -1


		do while not RecordSet.eof

			RecordCount = RecordCount + 1

			if (RecordCount > Start-1) and (RecordCount < Start+PageSize) then

				CustomerID = RecordSet("CustomerID")

				CustomerBalance = GetCustomerBalance(CustomerID)
				CustomerInvoiceCount = GetCustomerInvoiceCount(CustomerID)

				EBAGetHandler_CreateNewRecord(CustomerID)
					EBAGetHandler_DefineRecordFieldValue "CustomerID", CustomerID
					EBAGetHandler_DefineRecordFieldValue "CustomerName", RecordSet("CustomerName")
					EBAGetHandler_DefineRecordFieldValue "CustomerBalance", CustomerBalance
					EBAGetHandler_DefineRecordFieldValue "CustomerAddress", RecordSet("CustomerAddress")
					EBAGetHandler_DefineRecordFieldValue "CustomerPhone", RecordSet("CustomerPhone")
					EBAGetHandler_DefineRecordFieldValue "ContactEmail", RecordSet("ContactEmail")
					EBAGetHandler_DefineRecordFieldValue "CustomerInvoiceCount", CustomerInvoiceCount
				EBAGetHandler_SaveRecord

			end if

			RecordSet.MoveNext
		loop

		if RecordCount < 0 then

			EBAGetHandler_CreateNewRecord(1)
					EBAGetHandler_DefineRecordFieldValue "CustomerID", "0"
					EBAGetHandler_DefineRecordFieldValue "CustomerName", "No matching."

					EBAGetHandler_DefineRecordFieldValue "CustomerBalance", ""
					EBAGetHandler_DefineRecordFieldValue "CustomerInvoiceCount", ""

			EBAGetHandler_SaveRecord

		end if

		EBAGetHandler_CompleteGet

	end if
























	if Request.Querystring("grid") = "NotesGrid" then


		NewQuery = "SELECT * FROM tblInvoices"

		if (ucase(CompanyID) = "ALL") then
			NewQuery = NewQuery & " WHERE InvoiceNotes <> '' AND ProductID = '' ORDER BY InvoiceDate DESC"
		else
			NewQuery = NewQuery & " WHERE InvoiceNotes <> '' AND CustomerID = " & CompanyID  & " ORDER BY InvoiceDate DESC"

		end if


		Set RecordSet = objConn.execute(NewQuery)


		' *******************************************************************
		' Lets Set up the Output
		' *******************************************************************

		EBAGetHandler_ProcessRecords   ' We set up the getHandler and define the column CustomerID as our Index

		' First we define how many columns we are sending in each record, and name each field.

		' We will do this by using the EBAGetHandler_DefineField function. We will name each
		' field of data after its column name in the database.

		EBAGetHandler_DefineField("ProductID")

		EBAGetHandler_DefineField("InvoiceDate")
		EBAGetHandler_DefineField("InvoiceNotes")
		EBAGetHandler_DefineField("CustomerID")

		EBAGetHandler_DefineField("InvoiceID")

		' *******************************************************************
		' Lets loop through our data and send it to the grid
		' *******************************************************************


		RecordCount = -1


		do while not RecordSet.eof


			RecordCount = RecordCount + 1

			if (RecordCount > Start-1) and (RecordCount < Start+PageSize) then

				InvoiceID = RecordSet("InvoiceID")

				InvoiceDate = RecordSet("InvoiceDate")

				EBAGetHandler_CreateNewRecord(InvoiceID)
					EBAGetHandler_DefineRecordFieldValue "ProductID", RecordSet("ProductID")

					EBAGetHandler_DefineRecordFieldValue "InvoiceDate", EBAGetHandler_ConvertDate(InvoiceDate)
					EBAGetHandler_DefineRecordFieldValue "InvoiceNotes", RecordSet("InvoiceNotes")
					EBAGetHandler_DefineRecordFieldValue "CustomerID", RecordSet("CustomerID")

					EBAGetHandler_DefineRecordFieldValue "InvoiceID", InvoiceID
				EBAGetHandler_SaveRecord

			end if

			RecordSet.MoveNext
		loop


		if RecordCount < 0 then

			EBAGetHandler_CreateNewRecord(1)
				EBAGetHandler_DefineRecordFieldValue "ProductID", "1"
				EBAGetHandler_DefineRecordFieldValue "InvoiceDate", ""
				EBAGetHandler_DefineRecordFieldValue "InvoiceNotes", "No notes."
				EBAGetHandler_DefineRecordFieldValue "CustomerID", CompanyID
				EBAGetHandler_DefineRecordFieldValue "InvoiceID", "1"
			EBAGetHandler_SaveRecord

		end if

		EBAGetHandler_CompleteGet

	end if




























	if Request.Querystring("grid") = "ProductGrid" then


		NewQuery = "SELECT * FROM tblProducts ORDER BY ProductName DESC"
		Set RecordSet = objConn.execute(NewQuery)

		' *******************************************************************
		' Lets Set up the Output
		' *******************************************************************

		EBAGetHandler_ProcessRecords   ' We set up the getHandler and define the column CustomerID as our Index

		' First we define how many columns we are sending in each record, and name each field.

		' We will do this by using the EBAGetHandler_DefineField function. We will name each
		' field of data after its column name in the database.

		EBAGetHandler_DefineField("ProductName")

		EBAGetHandler_DefineField("UnitCost")


		' *******************************************************************
		' Lets loop through our data and send it to the grid
		' *******************************************************************

		RecordCount = -1


		do while not RecordSet.eof

			RecordCount = RecordCount + 1

				ProductID = RecordSet("ProductID")

				EBAGetHandler_CreateNewRecord(ProductID)
					EBAGetHandler_DefineRecordFieldValue "ProductName", RecordSet("ProductName")

					EBAGetHandler_DefineRecordFieldValue "UnitCost", RecordSet("UnitCost")
				EBAGetHandler_SaveRecord

			RecordSet.MoveNext
		loop

		EBAGetHandler_CompleteGet

	end if

%>

